#pragma semicolon 1

//#define SM_GGDM_DEBUG 1

#include <cstrike>
#include <sourcemod>
#include <sdktools>
#include <ggdm>

public Plugin:myinfo = 
{
    name = "DeathMatch:SM",
    author = GGDM_AUTHORS,
    description = "DeathMatch:SM for SourceMod.",
    version = GGDM_VERSION,
    url = GGDM_URL
};

new Handle:g_Respawn[MAXPLAYERS + 1]    = {INVALID_HANDLE, ...};
new Handle:g_Cvar_RemoveRagdolls          = INVALID_HANDLE;
new g_ragdollrem;
new g_WeaponParent;

#define MAXPLAYERS_BYTES MAXPLAYERS / 32

new g_eliminationVictims[MAXPLAYERS + 1][MAXPLAYERS_BYTES];
new bool:g_eliminationCanNotRespawn[MAXPLAYERS + 1];
new Handle:g_Cvar_Elimination = INVALID_HANDLE;
new bool:g_elimination;

new Handle:g_Cvar_RespawnTime           = INVALID_HANDLE;
new Float:g_respawnTime;
new Handle:g_Cvar_RemoveWeapons         = INVALID_HANDLE;
new bool:g_removeWeapons;
new bool:g_roundStarted;
new g_playerClass[MAXPLAYERS + 1];

public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
    new client = GetClientOfUserId(GetEventInt(event, "userid"));
    
    if ( g_elimination )
    {
        // clear victim's victims
        g_eliminationVictims[client][0] = 0;
        if ( MaxClients > 32 )
        {
            for (new i = 1; i < MAXPLAYERS_BYTES; i++)
            {
                g_eliminationVictims[client][i] = 0;
            }
        }
    }
    
    g_eliminationCanNotRespawn[client] = false;
    return Plugin_Continue;
}

public OnPluginStart()
{
    g_Cvar_RespawnTime = CreateConVar("sm_ggdm_respawntime", "2.0", "Respawn time");
    g_respawnTime = GetConVarFloat(g_Cvar_RespawnTime);
    g_Cvar_RemoveWeapons = CreateConVar("sm_ggdm_removeweapons", "1", "Remove weapons");
    g_removeWeapons = GetConVarBool(g_Cvar_RemoveWeapons);
    
    new Handle:Cvar_Version = CreateConVar("sm_ggdm_version", GGDM_VERSION, "GunGame Deathmatch", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
    /* Just to make sure they it updates the convar version if they just had the plugin reload on map change */
    SetConVarString(Cvar_Version, GGDM_VERSION);
    
    g_Cvar_RemoveRagdolls = CreateConVar("sm_ggdm_removeragdolls", "1", "1 RemoveRagdolls on 0 is off", FCVAR_PLUGIN|FCVAR_REPLICATED|FCVAR_NOTIFY);
    g_Cvar_Elimination    = CreateConVar("sm_ggdm_elimination", "0", "1 Elimination on 0 is off");
    g_ragdollrem        = GetConVarBool(g_Cvar_RemoveRagdolls);
    g_elimination       = GetConVarBool(g_Cvar_Elimination);
    
    HookConVarChange(g_Cvar_Elimination, CvarChanged);
    HookConVarChange(g_Cvar_RespawnTime, CvarChanged);
    HookConVarChange(g_Cvar_RemoveWeapons, CvarChanged);
    HookConVarChange(g_Cvar_RemoveRagdolls, CvarChanged);
    
    g_WeaponParent = FindSendPropOffs("CBaseCombatWeapon", "m_hOwnerEntity");

    HookEvent("player_death", Event_PlayerDeath);
    HookEvent("round_end", Event_RoundEnd, EventHookMode_PostNoCopy);
    HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
    HookEvent("player_spawn", Event_PlayerSpawn);
    HookEvent("player_team", Event_PlayerTeam);
    g_roundStarted = true;
    RegConsoleCmd("joinclass", Event_JoinClass);
}

public Action:Event_JoinClass(client, args)
{
    #if defined SM_GGDM_DEBUG
        if ( args )
        {
            decl String:class[64];
            GetCmdArg(1, class, sizeof(class));
            LogError("[AUTO-RESPAWN-CLASS] client=%i args=%i team=%i class=%s", client, args, GetClientTeam(client), class);
        }
        else
        {
            LogError("[AUTO-RESPAWN-CLASS] client=%i args=%i team=%i", client, args, GetClientTeam(client));
        }
    #endif
    g_Respawn[client] = CreateTimer(g_respawnTime, ExecRespawn, client);
    g_playerClass[client] = 1;
}

public CvarChanged(Handle:cvar, const String:oldValue[], const String:newValue[])
{
    if ( cvar == g_Cvar_Elimination )
    {
        g_elimination = GetConVarBool(g_Cvar_Elimination);
        return;
    }
    if ( cvar == g_Cvar_RespawnTime )
    {
        g_respawnTime = GetConVarFloat(g_Cvar_RespawnTime);
        if ( g_respawnTime < 2 )
        {
            g_respawnTime = 2.0;
        }
        return;
    }
    if ( cvar == g_Cvar_RemoveWeapons )
    {
        g_removeWeapons = GetConVarBool(g_Cvar_RemoveWeapons);
        return;
    }
    if ( cvar == g_Cvar_RemoveRagdolls )
    {
        g_ragdollrem = GetConVarBool(g_Cvar_RemoveRagdolls);
        return;
    }
}

public Action:Event_RoundEnd(Handle:event,const String:name[],bool:dontBroadcast)
{
    g_roundStarted = false;
}

public Action:Event_RoundStart(Handle:event,const String:name[],bool:dontBroadcast)
{
    g_roundStarted = true;
}

public Action:Event_PlayerDeath(Handle:event,const String:name[],bool:dontBroadcast)
{
    new client = GetClientOfUserId(GetEventInt(event, "userid"));

    if ( g_removeWeapons )
    {
        new maxent = GetMaxEntities(), String:weapon[64];
        for (new i=MaxClients;i<maxent;i++)
        {
            if ( IsValidEdict(i) && IsValidEntity(i) && GetEntDataEnt2(i, g_WeaponParent) == -1 )
            {
                GetEdictClassname(i, weapon, sizeof(weapon));
                if ( ( StrContains(weapon, "weapon_") != -1 || StrContains(weapon, "item_") != -1 ) )
                        RemoveEdict(i);
            }
        }
    }
    
    //Remove Ragdolls after 1.5 seconds (must be less than respawn time)
    //nice to watch ragdolls fligh first.
    if ( g_ragdollrem )
    {
        CreateTimer(1.5, RemRagDoll, client);
    }
        
    if ( !IsClientInGame(client) )
    {
        return;
    }
    
    if ( g_elimination )
    {
        new killer = GetClientOfUserId(GetEventInt(event, "attacker"));
        
        // store victim
        SaveVictim(killer, client);
        
        // respawn victim's victims
        RespawnVictims(client);
    }
    else
    {
        //Respawn after 2 seconds
        g_Respawn[client] = CreateTimer(g_respawnTime, ExecRespawn, client);
    }    
}

SaveVictim(killer, client)
{
    #if defined SM_GGDM_DEBUG
        LogError("[DEBUG] SaveVictim(killer=%i, client=%i)", killer, client);
    #endif
    if ( killer && (killer != client) && ( GetClientTeam(client) != GetClientTeam(killer) ) )
    {
        #if defined SM_GGDM_DEBUG
            LogError("[DEBUG] clientHigh=%i, clientLow=%i)", client >> 5, 1 << ( (client-1)&31 ) );
            LogError("[DEBUG] g_eliminationVictims = %i", g_eliminationVictims[killer][client >> 5] );
        #endif
        g_eliminationVictims[killer][client >> 5] |= ( 1 << ( (client-1)&31 ) );
        #if defined SM_GGDM_DEBUG
            LogError("[DEBUG] g_eliminationVictims = %i", g_eliminationVictims[killer][client >> 5] );
        #endif
        g_eliminationCanNotRespawn[client] = true;
    }
    else
    {
        //Respawn after 2 seconds
        g_Respawn[client] = CreateTimer(g_respawnTime, ExecRespawn, client);
    }
}

RespawnVictims(client)
{
    #if defined SM_GGDM_DEBUG
        LogError("[DEBUG] RespawnVictims(client=%i)", client);
    #endif
    new victims     = g_eliminationVictims[client][0];
    #if defined SM_GGDM_DEBUG
        LogError("[DEBUG] victims = %i", victims);
    #endif

    // check if client has no victims
    if ( !victims )
    {
        if ( MaxClients <= 32 )
        {
            return;
        }
        
        new bool:empty = true;
        for (new i = 1; i < MAXPLAYERS_BYTES; i++)
        {
            if ( g_eliminationVictims[client][i] )
            {
                empty = false;
                break;
            }
        }
        if ( empty )
        {
            return;
        }
    }
    
    new clientLow   = 1;
    new clientHigh  = 0;
    for ( new i = 1; i <= MaxClients; i++ )
    {
        if ( victims & clientLow )
        {
            #if defined SM_GGDM_DEBUG
                LogError("[DEBUG] Respawn: clientLow=%i clientHigh=%i i=%i ", clientLow, clientHigh, i);
            #endif
            g_Respawn[i] = CreateTimer(g_respawnTime, ExecRespawn, i);
            g_eliminationCanNotRespawn[i] = false;
        }
        
        if ( i & 31 )
        {
            clientLow = clientLow<<1;
            continue;
        }
        
        clientLow   = 1;
        clientHigh++;
        if ( clientHigh < MAXPLAYERS_BYTES) 
        {
            victims     = g_eliminationVictims[client][clientHigh];
        }
    }
    
    // clear victim's victims
    g_eliminationVictims[client][0] = 0;
    if ( MaxClients > 32 )
    {
        for (new i = 1; i < MAXPLAYERS_BYTES; i++)
        {
            g_eliminationVictims[client][i] = 0;
        }
    }
}

public Action:ExecRespawn(Handle:timer, any:client)
{
    if ( client && IsClientInGame(client) && (GetClientTeam(client) > 1) && (!IsPlayerAlive(client)) && g_playerClass[client] )
    {
        if ( !g_roundStarted )
        {
            PrintToChat(client,"\x01\x04[GGDM] You will respawn next round");
        }
        else
        {
            #if defined SM_GGDM_DEBUG
                decl String:name[31];
                GetClientName(client, name, sizeof(name));
                LogError("[RESPAWN] client=%i name=%s", client, name);
            #endif
            CS_RespawnPlayer(client);
        }
    }    
    g_Respawn[client] = INVALID_HANDLE;
    return Plugin_Stop;
}

public Action:RemRagDoll(Handle:timer, any:client)
{
    if (!IsValidEntity(client))
    {
        return Plugin_Stop;
    }
    
    new ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
    if (ragdoll<0)
    {
        return Plugin_Stop;
    }   
    AcceptEntityInput(ragdoll, "kill");
    
    return Plugin_Stop;
}

public Event_PlayerTeam(Handle:event, const String:name[], bool:dontBroadcast)
{
    new newTeam = GetEventInt(event, "team");
    new client = GetClientOfUserId(GetEventInt(event, "userid"));
    
    if ( !client || (newTeam < 2) )
    {
        return;
    }
    
    #if defined SM_GGDM_DEBUG
        LogError("[AUTO-RESPAWN-TEAM] client=%i", client);
    #endif
    
    if ( IsFakeClient(client) )
    {
        g_playerClass[client] = 1;
        // Fake clients does not exec joinclass, so we need to spawn them 
        // just when they joined team
        g_Respawn[client] = CreateTimer(g_respawnTime, ExecRespawn, client);
    }
    else
    {
        g_playerClass[client] = 0;
    }
}

