
//#define SM_GGDM_DEBUG 1

#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <ggdm>

public Plugin:myinfo = 
{
    name = "DeathMatch:SM Spawn Protection",
    author = GGDM_AUTHORS,
    description = "DeathMatch:SM Spawn Protection for SourceMod.",
    version = GGDM_VERSION,
    url = GGDM_URL
};

new Handle:g_Cvar_SPTime;
new Handle:g_Cvar_ChangeColor;
new Float:g_SPTime;
new bool:g_ChangeColor;

new g_RenderModeOffset;
new g_RenderClrOffset;
new g_Color[4] = {255, 255, 255, 128};
new g_NormColor[4] = {255, 255, 255, 255};

public OnPluginStart()
{
    g_Cvar_SPTime = CreateConVar("sm_ggdm_sptime", "2", "Sets the amount of seconds user's will be protected from getting killed on their respawn");
    g_Cvar_ChangeColor = CreateConVar("sm_ggdm_spchangecolor", "1", "Change color on spawn protected players");
    
    g_SPTime = GetConVarFloat(g_Cvar_SPTime);
    g_ChangeColor = GetConVarBool(g_Cvar_ChangeColor);
    
    HookConVarChange(g_Cvar_SPTime, CvarChanged);
    HookConVarChange(g_Cvar_ChangeColor, CvarChanged);
    
    g_RenderModeOffset = FindSendPropOffs("CCSPlayer", "m_nRenderMode");
    g_RenderClrOffset = FindSendPropOffs("CCSPlayer", "m_clrRender");
    
    HookEvent("player_spawn", PlayerSpawn);
}

public CvarChanged(Handle:cvar, const String:oldValue[], const String:newValue[])
{
    if ( cvar == g_Cvar_SPTime )
    {
        g_SPTime = GetConVarFloat(g_Cvar_SPTime);
        return;
    }
    if ( cvar == g_Cvar_ChangeColor )
    {
        g_ChangeColor = GetConVarBool(g_Cvar_ChangeColor);
        return;
    }
}

public Action:PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
    new client = GetClientOfUserId(GetEventInt(event, "userid"));
    new Team = GetClientTeam(client);
    
    if ( IsPlayerAlive(client) && (Team == 2 || Team == 3) )
    {
        SpawnProtectClient(client);
    }
    
    return Plugin_Continue;
}

SpawnProtectClient(client)
{
    if ( !g_SPTime )
    {
        return;
    }
        
    SetEntProp(client, Prop_Data, "m_takedamage", 0, 1);
    CreateTimer(g_SPTime, RemoveSpawnProtection, client);
    
    if ( g_ChangeColor )
    {
        UTIL_Render(client, g_Color);
    }
    
    return;
}

public Action:RemoveSpawnProtection(Handle:Timer, any:client)
{
    if ( !IsClientInGame(client) || !IsPlayerAlive(client) )
    {
        return;
    }
    SetEntProp(client, Prop_Data, "m_takedamage", 2, 1);
    
    if ( g_ChangeColor )
    {
        UTIL_Render(client, g_NormColor);
    }
    
    return;
}

UTIL_Render(client, const color[4])
{
    new mode = (color[3] == 255) ? K_RENDER_NORMAL : K_RENDER_TRANS_COLOR;
    
    SetEntData(client, g_RenderModeOffset, mode, 1);
    SetEntDataArray(client, g_RenderClrOffset, color, 4, 1);
    ChangeEdictState(client);
}
